---
title: Window.controllers
slug: Web/API/Window/controllers
tags:
  - API
  - HTML DOM
  - NeedsCompatTable
  - NeedsExample
  - NeedsMarkupWork
  - Non-standard
  - Property
  - Reference
  - Window
---
<div>{{APIRef}}{{non-standard_header}}</div>

<p>The <code><strong>controllers</strong></code> property of the {{domxref("Window")}} interface returns the XUL controllers of the chrome window.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>controllers</var> = <em>window</em>.controllers
</pre>

<ul>
 <li><code>controllers</code> is an object of type <a href="/en-US/docs/XULControllers"><code>XULControllers</code></a> (<a href="/en-US/docs/XPCOM_Interface_Reference/nsIControllers"><code>nsIControllers</code></a>).</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<p>XUL-specific. Not part of specification.</p>

<div class="note">
<p>By default, a window's controller contains the code that supports the global window commands.</p>

<p>Chrome code can add controllers (to be used in conjunction with the <code>goDoCommand</code> and <code>goUpdateCommand</code> functions in globalOverlay.js).</p>

<p>However, the added controllers must be explicitly removed when the window is unloaded, as this is not done automatically.</p>

<p>Each missing removal can cause</p>
<a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=415775">bug 415775</a>:

<pre>ASSERTION: XPConnect is being called on a scope without a 'Components' property!</pre>
</div>
